#include <PalmOS.h>
#include "TestRsc.h"
#include "TestDef.h"

extern Boolean TestFormHandleEvent (EventType * event);
static void StopApplication (void);

//TestCode Start
Ca_PrefData Ca_PrefGetData, Ca_PrefSetData;
short Stop_flag;
//TestCode End

//File Local Value
MenuBarPtr CurrentMenu;

//--------------------------------------------------------
//@AvP[VJn
//--------------------------------------------------------
static UInt16 StartApplication (void){
	Err err = 0;
	UInt32 currentRecordID = 0;
	Boolean recordFound = false;
//TestCode Start
	Stop_flag = 0;
//TestCode End
	return (err);
}

//--------------------------------------------------------
//@AvP[V~
//--------------------------------------------------------
static void StopApplication (void){
	//SẴtH[N[Y
	FrmCloseAllForms ();
}

/***********************************************************************
 * FUNCTION:    ApplicationHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and sets the event
 *              handler for the form loaded.
 *
 * PARAMETERS:  event  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event was handled and should not be passed
 *              to a higher level handler.
 ***********************************************************************/
static Boolean ApplicationHandleEvent (EventType * event){
	UInt16 formID;
	FormPtr frm;

	if (event->eType == frmLoadEvent){
		// Load the form resource.
		formID = event->data.frmLoad.formID;
		frm = FrmInitForm (formID);
		FrmSetActiveForm (frm);
		
		// Set the event handler for the form.  The handler of the currently
		// active form is called by FrmHandleEvent each time it receives an
		// event.
		switch (formID){
		case TestForm:
			FrmSetEventHandler (frm, TestFormHandleEvent);
			break;
		}
		return (true);
	}
	return (false);
}


/***********************************************************************
 * FUNCTION:    EventLoop
 *
 * DESCRIPTION: This routine is the event loop for the Kyoto
 *              aplication.  
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 ***********************************************************************/
static void EventLoop (void){
	UInt16 error;
	EventType event;

	do{
		EvtGetEvent (&event, evtWaitForever);

		if (! SysHandleEvent (&event))

			if (! MenuHandleEvent (CurrentMenu, &event, &error))

				if (! ApplicationHandleEvent (&event))

					FrmDispatchEvent (&event); 

//TestCode Start
//	}while (event.eType != appStopEvent );
	}while (event.eType != appStopEvent && Stop_flag == 0 );
//TestCode End
}


//--------------------------------------------------------
// DESCRIPTION: TvvOuTestvCvO
//--------------------------------------------------------
UInt32	PilotMain (UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags){
	UInt16 error;
	unsigned short prefsSize;

	if (cmd == sysAppLaunchCmdNormalLaunch) {
		error = StartApplication ();
		if (error) return (error);

//TestCode Start
		prefsSize = sizeof (Ca_PrefData);
		if( (PrefGetAppPreferences (Ca_From_CrID, Ca_PROF_ID, &Ca_PrefGetData, &prefsSize, true) == noPreferenceFound) 
		 || ( prefsSize != sizeof(Ca_PrefData))) {
			Ca_PrefGetData.From = 0;
		}
//TestCode End
	}

//TestCode Start
	Ca_PrefSetData.From = 0;
	PrefSetAppPreferences (Ca_From_CrID, Ca_PROF_ID, Ca_VersionNum, &Ca_PrefSetData, sizeof (Ca_PrefData), true);
//TestCode End

	FrmGotoForm(TestForm);
	EventLoop ();
	StopApplication ();

	return (0);
}
