//*****************************************************************************
//* Copyright (c) 1994-2002 PalmSource, Inc.
//* Copyright (c) 2003-2004 Miday Workshop All rights reserved.
//*
//* File: Beam.c
//*****************************************************************************

#include <PalmOS.h>
#include <SonyCLIE.h>
#include <BtLib.h>
#include <BtExgLib.h>
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//private value
#define ALL_TRANS_CODE         0x0001
#define COLOR_TRANS_CODE       0x0002
#define COLOR_TEXT_TRANS_CODE  0x0004

#define Bmdescription  "HolidayData"
#define IrFilename     "MakeSpotBeam.Spot"
#define BtExgFile      ("MakeSpotBeam" "." Bm_DataType)
static char BtOpponentURL[100];

static char beam_label_work1[31];
static char beam_start_year[10], beam_start_month[10], beam_end_year[10], beam_end_month[10];
static unsigned short SendItem[] = { BeamWinStartYearCategoryTrigger, BeamWinStartMonthCategoryTrigger,
                                     BeamWinEndYearCategoryTrigger,   BeamWinEndMonthCategoryTrigger,
                                     BeamWinAllDataCheckBox,          BeamWinSendButton};
static unsigned short RecvItem[] = { BeamWinRecvButton,      BeamWinStartYearLabel,
                                     BeamWinStartMonthLabel, BeamWinEndYearLabel,
                                     BeamWinEndMonthLabel};

//--------------------------------------------------------
//@M
//  Reception processing.
//--------------------------------------------------------
void ReceiveData(ExgSocketPtr exgSocketP) {
	Err err;
	MemHandle        MemH;
	unsigned char    *MemP;
	Int16 size;
	Int16 recieved;
	short hd_size;
	short cmd_flag;
	unsigned long mem_size;

	err = ExgAccept(exgSocketP);	//M҂ɂ  (It is made the waiting for reception.)
	if (err == 0) {
		//wb_[f[^M  (Header data are received.)
		hd_size  = sizeof(Beam_hd);
		size     = hd_size;
		recieved = ExgReceive(exgSocketP, &Beam_hd, size, &err);

		//m  (A memory is secured.)
		mem_size = Beam_hd.total_byte + 2;
		MemH     = MemHandleNew(mem_size);

		//̃I[i[ύX  (The owner of a memory is changed.)
		MemHandleSetOwner(MemH, 0);
		MemP = MemHandleLock(MemH);
		cmd_flag = 1;  //=1 ԊOMł  (=1 Infrared reception)
		MemMove (&MemP[0], &cmd_flag, 2);
		MemMove (&MemP[2], &Beam_hd, hd_size);

		//JeS[f[^M  (Categorical data are received.)
		size = Beam_hd.total_byte - hd_size;
		if (size > 0 && recieved != 0 && err == 0) {
			recieved = ExgReceive(exgSocketP, &MemP[hd_size+2], size, &err);
		}

		MemHandleUnlock(MemH);

		ExgDisconnect(exgSocketP, err);//ڑ  (Connection is canceled.)

		if (err != 0) {
			MemHandleFree(MemH);
		} else {
			exgSocketP->goToCreator            = Df_CreaID;
			exgSocketP->goToParams.matchCustom = (UInt32)MemH;
		}
	}
	return;
}

//--------------------------------------------------------
//@Mf[^̃obNAbv
//  Backup processing of the received data.
//--------------------------------------------------------
void ReceiveDataBackup(unsigned char *MemP) {
	unsigned char  *beamMemP;

	//wb_[͂Ŏ荞  (A header is taken here.)
	MemMove (&Beam_hd, &MemP[0], sizeof(Beam_hd));
	BeamMemH = MemHandleNew(Beam_hd.total_byte);
	beamMemP = MemHandleLock(BeamMemH);
	MemMove (beamMemP, MemP, Beam_hd.total_byte);
	MemHandleUnlock(BeamMemH);
}

//--------------------------------------------------------
//@Mf[^̊i[
//  Storing processing of the received data.
//--------------------------------------------------------
static void ReceiveDataStore() {
	short year, month;
	unsigned char  *beamMemP;
	unsigned char red[31];
	short no, ia, ib, ix;
	unsigned long len_byte;
	unsigned char text_len;

	beamMemP = MemHandleLock(BeamMemH);
	len_byte = sizeof(Beam_hd);

	//JeS[S  (Category 4)
	for ( ib=0; ib<Beam_hd.mounth_number; ib++ ) {
		MemMove (&year, &beamMemP[len_byte], 2);
		MemMove (&month, &beamMemP[len_byte+2], 2);
		GetRedDataOfArray(year, month, red, &no);
		RedData_Extends(Beam_hd.color_number, red, (unsigned long*)&beamMemP[len_byte+4]);
		ia = SetRedDataOfArray(year, month, red, no);
		len_byte = len_byte + (Beam_hd.color_number+1) * 4;
	}

	//JeS[R  (Category 3)
	if ( (Beam_hd.beam_com & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
		if ( (Opt3.beam_flag & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
			MemMove(&Color_dev_type, &beamMemP[len_byte], 2);
			len_byte = len_byte + 2;
			for ( ix=0; ix<Beam_hd.color_number; ix++ ) {
				MemMove(&Color_def[ix].hol_flag, &beamMemP[len_byte],  22);
				MemMove(&text_len, &beamMemP[len_byte+22], 1);
				len_byte = len_byte + 23;
				if ( (Beam_hd.beam_com & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
					if ( (Opt3.beam_flag & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
						MemMove(&Color_def[ix].text[0], &beamMemP[len_byte], text_len+1);
					}
					len_byte = len_byte + 9;
				}
			}
		} else {
			//Fꍇ  (When the number of colors increases.)
			if ( Beam_hd.color_number > Color_win_max_color ) {
				for ( ix=Color_win_max_color; ix<Beam_hd.color_number; ix++ ) {
					Md_InitRedDate(ix);
				}
			}
		}
	} else {
		//Fꍇ  (When the number of colors increases.)
		if ( Beam_hd.color_number > Color_win_max_color ) {
			for ( ix=Color_win_max_color; ix<Beam_hd.color_number; ix++ ) {
				Md_InitRedDate(ix);
			}
		}
	}

	//Fꍇ  (When the number of colors increases.)
	if ( Beam_hd.color_number > Color_win_max_color ) {
		Color_win_max_color = Beam_hd.color_number;
	}

	MemHandleUnlock(BeamMemH);
	Dataupdateflag = 1;
}

//--------------------------------------------------------
//@M
//  Transmitting processing.
//--------------------------------------------------------
static void SendData() {
	MemHandle        MemH;
	unsigned char    *MemP;
	ExgSocketType exgSocket;
	Err err = 0;
	unsigned long len_byte, area_size, sent;
	short ix, all_flag;
	unsigned char text_len;

	// pPbg̐ݒ  (A packet is set up.)
	MemSet(&exgSocket, sizeof(exgSocket), 0);
	exgSocket.description = Bmdescription;
	exgSocket.length      = StrLen(exgSocket.description);
	if ( Beam_trnce_flag == 1 ) {
		exgSocket.name = IrFilename;
	} else {
		StrPrintF(BtOpponentURL, "%s%s%s", btexgPrefix, btexgSingleSufix, BtExgFile);
		exgSocket.count = 1;
		exgSocket.name  = BtOpponentURL;
	}

	// wb_̐ݒ  (A header is set up.)
	len_byte = sizeof(Beam_hd);
	Beam_hd.total_byte    = len_byte;
	Beam_hd.form_ver      = 3;
	Beam_hd.beam_ver      = Md_CPVersion;
	Beam_hd.color_number  = Color_win_max_color;
	Beam_hd.beam_com      = 0;
	if ( (Opt3.beam_flag & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
		Beam_hd.beam_com = Beam_hd.beam_com | COLOR_TRANS_CODE;
	}
	if ( (Opt3.beam_flag & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
		Beam_hd.beam_com = Beam_hd.beam_com | COLOR_TEXT_TRANS_CODE ;
	}

	Beam_hd.start_year  = Opt3.beam_st_year;
	Beam_hd.start_month = Opt3.beam_st_month;
	Beam_hd.end_year    = Opt3.beam_en_year;
	Beam_hd.end_month   = Opt3.beam_en_month;

	//GAm  (Area reservation)
	if ( (Opt3.beam_flag & ALL_TRANS_CODE) == ALL_TRANS_CODE ) {
		area_size = len_byte +
		            Yasumi_no * (Color_win_max_color + 1) * 4 +
		            34 * Color_win_max_color + 2;
		all_flag = 1;
	} else {
		area_size = len_byte + 
		            ((Beam_hd.end_year - Beam_hd.start_year)*12 + Beam_hd.end_month - Beam_hd.start_month + 1) * 
		            (Color_win_max_color + 1) * 4 +
		            34 * Color_win_max_color + 2;
		all_flag = 2;
	}
	MemH = MemHandleNew(area_size);
	MemP = MemHandleLock(MemH);

	//JeS[S  (Category 4)
	GetRedBeamData( all_flag, &Beam_hd.start_year, &Beam_hd.start_month, &Beam_hd.end_year, &Beam_hd.end_month,
	                (unsigned long *)&MemP[len_byte], &Beam_hd.mounth_number);
	len_byte = len_byte + Beam_hd.mounth_number * (Color_win_max_color + 1) * 4;

	if ( Beam_hd.mounth_number == 0 ) {
		FrmAlert(AltDataNotFound);
		MemHandleUnlock(MemH);
		MemHandleFree(MemH);
		return;
	}

	//JeS[R  (Category 3)
	if ( (Beam_hd.beam_com & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
		MemMove(&MemP[len_byte], &Color_dev_type, 2);
		len_byte = len_byte + 2;
		for ( ix=0; ix<Color_win_max_color; ix++ ) {
			MemMove(&MemP[len_byte],  &Color_def[ix].hol_flag, 22);
			text_len = StrLen(&Color_def[ix].text[0]);
			MemMove(&MemP[len_byte+22], &text_len, 1);
			len_byte = len_byte + 23;
			if ( (Beam_hd.beam_com & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
				MemMove(&MemP[len_byte], &Color_def[ix].text[0], Max_ColorText_no);
				len_byte = len_byte + Max_ColorText_no;
			
			}
		}
	}

	//wb_[  (The header)
	Beam_hd.total_byte = len_byte;
	MemMove(MemP, &Beam_hd, sizeof(Beam_hd));

	//M̐ݒ  (A setup of transmission)
	exgSocket.length = Beam_hd.total_byte;
	exgSocket.target = Df_CreaID;
	//M̏  (Initialization processing of transmission)
	err = ExgPut(&exgSocket);
	if (!err) {
		//f[^𑗐M  (Data is transmitted.)
		len_byte = Beam_hd.total_byte;
		sent     = ExgSend(&exgSocket, MemP, len_byte, &err);

		//ڑ  (Connection is canceled.)
		ExgDisconnect(&exgSocket, err);
	}

	MemHandleUnlock(MemH);
	MemHandleFree(MemH);
	return;
}

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean BeamWinHandleEvent (EventType * event) {
	FormPtr frm;
	MemHandle StringH;
	char      *StringP;
	short start_year, ix;
	char  work[20];
	Boolean handled = false;

	start_year = Start_year;

	frm = FrmGetFormPtr (BeamWin);

	if (event->eType == ctlSelectEvent) {
		switch (event->data.ctlSelect.controlID) {
		case BeamWinSendButton:
			lstTable = (ListType *)GetObjectPtr(BeamWinStartYearCategoryList);
			Opt3.beam_st_year  = LstGetSelection(lstTable) + Start_year;
			lstTable = (ListType *)GetObjectPtr(BeamWinStartMonthCategoryList);
			Opt3.beam_st_month = LstGetSelection(lstTable) + 1;
			lstTable = (ListType *)GetObjectPtr(BeamWinEndYearCategoryList);
			Opt3.beam_en_year  = LstGetSelection(lstTable) + Start_year;
			lstTable = (ListType *)GetObjectPtr(BeamWinEndMonthCategoryList);
			Opt3.beam_en_month = LstGetSelection(lstTable) + 1;

			if ( ( Opt3.beam_st_year > Opt3.beam_en_year ) ||
			     ( Opt3.beam_st_year == Opt3.beam_en_year && Opt3.beam_st_month > Opt3.beam_en_month) ) {
				FrmAlert(AltRangeError);
				break;
			}

			if ( CtlGetValue(GetObjectPtr(BeamWinAllDataCheckBox)) == 1 ) {
				Opt3.beam_flag = Opt3.beam_flag | ALL_TRANS_CODE;
			} else {
				if ( (Opt3.beam_flag & ALL_TRANS_CODE) == ALL_TRANS_CODE ) {
					Opt3.beam_flag = Opt3.beam_flag ^ ALL_TRANS_CODE;
				}
			}
			if ( CtlGetValue(GetObjectPtr(BeamWinColorCheckBox)) == 1 ) {
				Opt3.beam_flag = Opt3.beam_flag | COLOR_TRANS_CODE;
				if ( CtlGetValue(GetObjectPtr(BeamWinColorTextCheckBox)) == 1 ) {
					Opt3.beam_flag = Opt3.beam_flag | COLOR_TEXT_TRANS_CODE;
				} else {
					if ( (Opt3.beam_flag & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
						Opt3.beam_flag = Opt3.beam_flag ^ COLOR_TEXT_TRANS_CODE;
					}
				}
			} else {
				if ( (Opt3.beam_flag & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
					Opt3.beam_flag = Opt3.beam_flag ^ COLOR_TRANS_CODE;
				}
				if ( (Opt3.beam_flag & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
					Opt3.beam_flag = Opt3.beam_flag ^ COLOR_TEXT_TRANS_CODE;
				}
			}

			Opt3p.beam_st_year  = Opt3.beam_st_year;
			Opt3p.beam_st_month = Opt3.beam_st_month;
			Opt3p.beam_en_year  = Opt3.beam_en_year;
			Opt3p.beam_en_month = Opt3.beam_en_month;
			Opt3p.beam_flag     = Opt3.beam_flag;
			PrefSetAppPreferences (Df_CreaID, 2, Md_Version, &Opt3p, sizeof(OPTIONS3), true);

			SendData();

			Beam_trnce_flag = 0;
			FrmReturnToForm (0);
			break;
		case BeamWinRecvButton:
			DeleteRedDataOfArray(Beam_hd.start_year, Beam_hd.start_month, Beam_hd.end_year, Beam_hd.end_month);

			if ( CtlGetValue(GetObjectPtr(BeamWinColorCheckBox)) == 1 ) {
				Opt3.beam_flag = Opt3.beam_flag | COLOR_TRANS_CODE;
				if ( CtlGetValue(GetObjectPtr(BeamWinColorTextCheckBox)) == 1 ) {
					Opt3.beam_flag = Opt3.beam_flag | COLOR_TEXT_TRANS_CODE;
				} else {
					if ( (Opt3.beam_flag & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
						Opt3.beam_flag = Opt3.beam_flag ^ COLOR_TEXT_TRANS_CODE;
					}
				}
			} else {
				if ( (Opt3.beam_flag & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
					Opt3.beam_flag = Opt3.beam_flag ^ COLOR_TRANS_CODE;
				}
				if ( (Opt3.beam_flag & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
					Opt3.beam_flag = Opt3.beam_flag ^ COLOR_TEXT_TRANS_CODE;
				}
			}

			Opt3p.beam_flag     = Opt3.beam_flag;
			PrefSetAppPreferences (Df_CreaID, 2, Md_Version, &Opt3p, sizeof(OPTIONS3), true);

			if ( Beam_hd.beam_ver == Md_CPVersion ) {   //version 3.2 add
				ReceiveDataStore();
			} else {
				FrmAlert(AltBeamVersion);   //version 3.2 add
			}
			MemHandleFree(BeamMemH);

			Beam_trnce_flag = 0;
			FrmReturnToForm (0);
			FrmGotoForm (MainWin);
			break;
		case BeamWinCancelButton:
			if ( Beam_trnce_flag == 2 || Beam_trnce_flag == 4 ) {
				MemHandleFree(BeamMemH);
			}

			Beam_trnce_flag = 0;
			FrmReturnToForm (0);
			break;
		case BeamWinColorCheckBox:
			if ( Beam_trnce_flag == 1 || Beam_trnce_flag == 3 ) {
				if ( CtlGetValue(GetObjectPtr(BeamWinColorCheckBox)) == 1 ) {
					CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),1);
					CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), true);
				} else {
					CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),0);
					CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), false);
				}
			} else {
				if ( CtlGetValue(GetObjectPtr(BeamWinColorCheckBox)) == 1 ) {
					if ( (Beam_hd.beam_com & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
						CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),1);
						CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), true);
					} else {
						CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),0);
						CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), false);
					}
				} else {
					CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),0);
					CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), false);
				}
			}
			FrmDrawForm (frm);
			break;
		}

	} else if (event->eType == menuEvent) {
		switch (event->data.menu.itemID) {
		case AboutAboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	} else if (event->eType == frmOpenEvent) {

		if ( Beam_trnce_flag == 1 || Beam_trnce_flag == 3 ) {
			if ( Opt3.beam_st_year-Start_year < 0 || Opt3.beam_st_year-Start_year > 9 ) {
				Opt3.beam_st_year  = Opt3.st_year;
				Opt3.beam_st_month = Opt3.st_month;
			}
			if ( Opt3.beam_st_month < 1 || Opt3.beam_st_month > 12 ) {
				Opt3.beam_st_month = Opt3.st_month;
			}
			if ( Opt3.beam_en_year-Start_year < 0 || Opt3.beam_en_year-Start_year > 9 ) {
				Opt3.beam_en_year  = Opt3.en_year;
				Opt3.beam_en_month = Opt3.en_month;
			}
			if ( Opt3.beam_en_month < 1 || Opt3.beam_en_month > 12 ) {
				Opt3.beam_en_month = Opt3.en_month;
			}

			for ( ix=0; ix<Year_no; ix++ ) {
				Beam_Start_Year_table[ix] = Beam_Start_Year_data[ix];
				Beam_End_Year_table[ix]   = Beam_End_Year_data[ix];
			}

			for (ix=0;ix<Year_no;ix++) {
				StrIToA(work, start_year+ix);
				StrCat(work, Year_suffix);
				StrCopy(Beam_Start_Year_data[ix],  work);
				StrCopy(Beam_End_Year_data[ix],    work);
			}

			lstTable = (ListType *)GetObjectPtr(BeamWinStartYearCategoryList);
			LstSetListChoices(lstTable, Beam_Start_Year_table, Year_no);
			LstSetHeight(lstTable, Year_no);
			LstSetSelection(lstTable, Opt3.beam_st_year-Start_year);
			CtlSetLabel(GetObjectPtr(BeamWinStartYearCategoryTrigger),LstGetSelectionText(lstTable, Opt3.beam_st_year-Start_year));

			lstTable = (ListType *)GetObjectPtr(BeamWinEndYearCategoryList);
			LstSetListChoices(lstTable, Beam_End_Year_table, Year_no);
			LstSetHeight(lstTable, Year_no);
			LstSetSelection(lstTable, Opt3.beam_en_year-Start_year);
			CtlSetLabel(GetObjectPtr(BeamWinEndYearCategoryTrigger),LstGetSelectionText(lstTable, Opt3.beam_en_year-Start_year));

			for ( ix=0; ix<Month_no; ix++ ) {
				Beam_Start_Month_table[ix] = Beam_Start_Month_data[ix];
				Beam_End_Month_table[ix]   = Beam_End_Month_data[ix];
			}

			for (ix=0;ix<Month_no;ix++) {
				StrIToA(work, ix+1);
				StrCat(work, Month_suffix);
				StrCopy(Beam_Start_Month_data[ix],  work);
				StrCopy(Beam_End_Month_data[ix],    work);
			}
			lstTable = (ListType *)GetObjectPtr(BeamWinStartMonthCategoryList);
			LstSetListChoices(lstTable, Beam_Start_Month_table, Month_no);
			LstSetHeight(lstTable, Month_no);
			LstSetSelection(lstTable, Opt3.beam_st_month-1);
			CtlSetLabel(GetObjectPtr(BeamWinStartMonthCategoryTrigger),LstGetSelectionText(lstTable, Opt3.beam_st_month-1));

			lstTable = (ListType *)GetObjectPtr(BeamWinEndMonthCategoryList);
			LstSetListChoices(lstTable, Beam_End_Month_table, Month_no);
			LstSetHeight(lstTable, Month_no);
			LstSetSelection(lstTable, Opt3.beam_en_month-1);
			CtlSetLabel(GetObjectPtr(BeamWinEndMonthCategoryTrigger),LstGetSelectionText(lstTable, Opt3.beam_en_month-1));

			for (ix=0;ix<6;ix++) {
				CtlSetUsable(GetObjectPtr(SendItem[ix]), true);
			}
			for (ix=0;ix<5;ix++) {
				CtlSetUsable(GetObjectPtr(RecvItem[ix]), false);
			}

			if ( (Opt3.beam_flag & ALL_TRANS_CODE) == ALL_TRANS_CODE ) {
				CtlSetValue(GetObjectPtr(BeamWinAllDataCheckBox),1);
			} else {
				CtlSetValue(GetObjectPtr(BeamWinAllDataCheckBox),0);
			}
			if ( (Opt3.beam_flag & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
				CtlSetValue(GetObjectPtr(BeamWinColorCheckBox),1);
				CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), true);
				if ( (Opt3.beam_flag & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
					CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),1);
				} else {
					CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),0);
				}
			} else {
				CtlSetValue(GetObjectPtr(BeamWinColorCheckBox),0);
				CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), false);
				CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),0);
			}

			StringH = DmGetResource(strRsc,StringBeam11);
			StringP = MemHandleLock(StringH);
			StrCopy(beam_label_work1, StringP);
			MemHandleUnlock(StringH);
			CtlSetLabel(GetObjectPtr(BeamWinLabel1), beam_label_work1);
		} else {
			for (ix=0;ix<6;ix++) {
				CtlSetUsable(GetObjectPtr(SendItem[ix]), false);
			}
			for (ix=0;ix<5;ix++) {
				CtlSetUsable(GetObjectPtr(RecvItem[ix]), true);
			}

			StrIToA(beam_start_year, Beam_hd.start_year);
			CtlSetLabel(GetObjectPtr(BeamWinStartYearLabel), beam_start_year);
			StrIToA(beam_start_month, Beam_hd.start_month);
			CtlSetLabel(GetObjectPtr(BeamWinStartMonthLabel), beam_start_month);
			StrIToA(beam_end_year, Beam_hd.end_year);
			CtlSetLabel(GetObjectPtr(BeamWinEndYearLabel), beam_end_year);
			StrIToA(beam_end_month, Beam_hd.end_month);
			CtlSetLabel(GetObjectPtr(BeamWinEndMonthLabel), beam_end_month);

			if ( (Beam_hd.beam_com & COLOR_TRANS_CODE) == COLOR_TRANS_CODE ) {
				CtlSetValue(GetObjectPtr(BeamWinColorCheckBox),1);
				CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), true);
				if ( (Beam_hd.beam_com & COLOR_TEXT_TRANS_CODE) == COLOR_TEXT_TRANS_CODE ) {
					CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),1);
				} else {
					CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), false);
					CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),0);
				}
			} else {
				CtlSetUsable(GetObjectPtr(BeamWinColorCheckBox), false);
				CtlSetValue(GetObjectPtr(BeamWinColorCheckBox),0);
				CtlSetUsable(GetObjectPtr(BeamWinColorTextCheckBox), false);
				CtlSetValue(GetObjectPtr(BeamWinColorTextCheckBox),0);
			}

			StringH = DmGetResource(strRsc,StringBeam12);
			StringP = MemHandleLock(StringH);
			StrCopy(beam_label_work1, StringP);
			MemHandleUnlock(StringH);
			CtlSetLabel(GetObjectPtr(BeamWinLabel1), beam_label_work1);
		}
		FrmDrawForm (frm);
		handled = true;
	}

	return (handled);
}
