//*****************************************************************************
//* Copyright (c) 2003-2004 Miday Workshop All rights reserved.
//*
//* File: get_hol_U.c
//*****************************************************************************

extern short GetDayOfTheWeek(short nen, short tuki, short *day_no);
extern void GetHoliday( short nen, short tuki, short *hol_no, short hol_day[] );

//--------------------------------------------------------
//@Nw肵čՓo
//  The national holiday of the month is calculated.
//--------------------------------------------------------
void GetHoliday( short nen, short tuki, short *hol_no, short hol_day[] ) {
//year           N        (Year)
//month                  (Month)
//hol_no         Փ̐  (The number of national holidays)
//hol_day        Փ      (national holidays)
	short start_day, ia, dum;

	*hol_no = 0;
	start_day = GetDayOfTheWeek(nen, tuki, &dum);
	switch (tuki) {
	case 1:
		*hol_no = 2;
		ia = 0;
		hol_day[ia] = 1;     	//U  (New Year's Day)
		if ( start_day == 0 ) hol_day[ia] = 2;
		if ( start_day == 6 ) {	// 1/1yjȂ12/31  (If 1/1 is Saturday, it is 12/31.)
			ia = 0;
		} else {
			ia = 1;
		}

		if (start_day < 2) {	//LOqta  Rj  (Birthday of Martin Luther King)
			hol_day[ia] = 16 - start_day;
		} else {
			hol_day[ia] = 23 - start_day;
		}
		break;
	case 2:
		*hol_no = 2;
		ia = 0;
		hol_day[ia] = 12;	//J[̒a  PQ  (Loncoln's birthday)
		if ( start_day == 3 ) hol_day[0] = 13;
		if ( start_day == 2 ) hol_day[0] = 11;

		ia = 1;
		if (start_day < 2) {	//哝̂̓  Rj  (Washington's Birthday)
			hol_day[ia] = 16 - start_day;
		} else {
			hol_day[ia] = 23 - start_day;
		}
		break;
	case 5:
		*hol_no = 1;
		ia = 0;
		if (start_day >= 6) {	//vǓLO  ŏIj  (Memorial Day)
			hol_day[ia] = 37 - start_day;
		} else {
			hol_day[ia] = 30 - start_day;
		}
		break;
	case 7:
		*hol_no = 1;
		ia = 0;
		hol_day[ia] = 4;	//ƗLO  S  (United States of America's Independence Day)
		if ( start_day == 4 ) hol_day[0] = 5;
		if ( start_day == 3 ) hol_day[0] = 3;
		break;
	case 9:
		*hol_no = 1;
		ia = 0;
		if (start_day < 2) {	//J  Pj  (Labor Day)
			hol_day[ia] = 2 - start_day;
		} else {
			hol_day[ia] = 9 - start_day;
		}
		break;
	case 10:
		*hol_no = 1;
		ia = 0;
		if (start_day < 2) {	//RuXEf[  Qj  (Columbus Day)
			hol_day[ia] = 9 - start_day;
		} else {
			hol_day[ia] = 16 - start_day;
		}
		break;
	case 11:
		*hol_no = 2;
		ia = 0;
		hol_day[ia] = 11;     	//Rl̓  PP  (Veterans Day)
		if ( start_day == 4 ) hol_day[ia] = 12;
		if ( start_day == 3 ) hol_day[ia] = 10;

		ia = 1;
		if (start_day < 5) {	//Ӎ  Sؗj  (Thanksgiving Day)
			hol_day[ia] = 26 - start_day;
		} else {
			hol_day[ia] = 33 - start_day;
		}
		break;
	case 12:
		*hol_no = 1;
		ia = 0;
		hol_day[ia] = 25;	//NX}X  QT  (Christmas Day)
		if ( start_day == 4 ) hol_day[ia] = 26;
		if ( start_day == 3 ) hol_day[ia] = 24;

		if ( start_day == 3 ) {// 1/1jȂ12/31  (If 1/1 is Friday, it is 12/31.)
			*hol_no = 2;
			ia = 1;
			hol_day[ia] = 31;
		}
		break;
	default:
		*hol_no = 0;
		break;
	}
}
